commit 844f6bc8ca9d1d3dabd1efe8ef495a29825ad5b9
Author: freddy77 <freddy77>
Date:   Thu Sep 18 08:51:19 2008 +0000

    more error set in odbc_tds2sql

diff --git a/ChangeLog b/ChangeLog
index c408cb8..2c30c24 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Sep 18 10:50:48 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/convert_tds2sql.c src/odbc/odbc.c:
+	* src/odbc/odbc_util.c:
+	- more error set in odbc_tds2sql
+
 Thu Sep 18 10:17:49 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/token.c: reduce use of #if
 
@@ -664,4 +669,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2612 2008/09/18 08:17:59 freddy77 Exp $
+$Id: ChangeLog,v 1.2613 2008/09/18 08:51:19 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index c0a3597..28f100c 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.109 2008/09/11 15:09:49 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.110 2008/09/18 08:51:21 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -439,7 +439,7 @@ int odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection);
 /*
  * convert_tds2sql.c
  */
-TDS_INT odbc_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen, const struct _drecord *drec_ixd);
+TDS_INT odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen, const struct _drecord *drec_ixd);
 
 /*
  * descriptor.c
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 50e8afb..2c4e218 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -39,14 +39,15 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.52 2008/09/11 15:09:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.53 2008/09/18 08:51:21 freddy77 Exp $");
 
 TDS_INT
-odbc_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
+odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
 	     const struct _drecord *drec_ixd)
 {
 	TDS_INT nDestSybType;
 	TDS_INT nRetVal = TDS_FAIL;
+	TDSCONTEXT *context = stmt->dbc->env->tds_ctx;
 
 	CONV_RESULT ores;
 
@@ -64,8 +65,10 @@ odbc_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen,
 	assert(desttype != SQL_C_DEFAULT);
 
 	nDestSybType = odbc_c_to_server_type(desttype);
-	if (nDestSybType == TDS_FAIL)
+	if (nDestSybType == TDS_FAIL) {
+		odbc_errs_add(&stmt->errs, "HY003", NULL);
 		return TDS_CONVERT_NOAVAIL;
+	}
 
 	/* special case for binary type */
 	if (desttype == SQL_C_BINARY) {
@@ -75,8 +78,10 @@ odbc_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen,
 			desttype = SQL_C_NUMERIC;
 			nDestSybType = SYBNUMERIC;
 			/* prevent buffer overflow */
-			if (destlen < sizeof(SQL_NUMERIC_STRUCT))
+			if (destlen < sizeof(SQL_NUMERIC_STRUCT)) {
+				odbc_errs_add(&stmt->errs, "07006", NULL);
 				return TDS_CONVERT_FAIL;
+			}
 			ores.n.precision = ((TDS_NUMERIC *) src)->precision;
 			ores.n.scale = ((TDS_NUMERIC *) src)->scale;
 		} else {
@@ -88,8 +93,10 @@ odbc_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen,
 				memcpy(dest, src, cplen);
 			} else {
 				/* if destlen == 0 we return only length */
-				if (destlen != 0)
-					ret = TDS_CONVERT_FAIL;
+				if (destlen != 0) {
+					odbc_errs_add(&stmt->errs, "07006", NULL);
+					return TDS_CONVERT_FAIL;
+				}
 			}
 			return ret;
 		}
@@ -122,8 +129,10 @@ odbc_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen,
 	} else {
 		nRetVal = tds_convert(context, srctype, src, srclen, nDestSybType, &ores);
 	}
-	if (nRetVal < 0)
+	if (nRetVal < 0) {
+		odbc_convert_err_set(&stmt->errs, nRetVal);
 		return nRetVal;
+	}
 
 	switch (desttype) {
 
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 408faf0..b7e7b85 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.497 2008/09/17 21:26:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.498 2008/09/18 08:51:21 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3667,10 +3667,9 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				} else {
 					data_ptr += odbc_get_octet_len(c_type, drec_ard) * curr_row;
 				}
-				len = odbc_tds2sql(context, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
+				len = odbc_tds2sql(stmt, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
 						      src, srclen, c_type, data_ptr, drec_ard->sql_desc_octet_length, drec_ard);
 				if (len < 0) {
-					odbc_convert_err_set(&stmt->errs, len);
 					row_status = SQL_ROW_ERROR;
 					break;
 				}
@@ -4741,12 +4740,9 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 							ODBC_RETURN(stmt, SQL_NO_DATA);
 						
 						if (cbValueMax > 2) {
-							len = odbc_tds2sql(context, nSybType, src + nread, 1, fCType, buf, sizeof(buf), NULL);
-							if (len < 2) {
-								if (len < 0) 
-									odbc_convert_err_set(&stmt->errs, len);
+							len = odbc_tds2sql(stmt, nSybType, src + nread, 1, fCType, buf, sizeof(buf), NULL);
+							if (len < 2)
 								ODBC_RETURN(stmt, SQL_ERROR);
-							}
 							*(TDS_CHAR *) rgbValue = buf[1];
 							*((TDS_CHAR *) rgbValue + 1) = 0;
 						
@@ -4800,11 +4796,9 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 			srclen = colinfo->column_cur_size;
 		}
 
-		*pcbValue = odbc_tds2sql(context, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
-		if (*pcbValue < 0) {
-			odbc_convert_err_set(&stmt->errs, *pcbValue);
+		*pcbValue = odbc_tds2sql(stmt, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
+		if (*pcbValue < 0)
 			ODBC_RETURN(stmt, SQL_ERROR);
-		}
 		
 		if (extra_bytes) {
 			colinfo->column_text_sqlgetdatapos += extra_bytes;
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 2122d0e..f13098b 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.102 2008/09/11 15:09:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.103 2008/09/18 08:51:22 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -113,7 +113,6 @@ void
 odbc_set_return_status(struct _hstmt *stmt, unsigned int n_row)
 {
 	TDSSOCKET *tds = stmt->dbc->tds_socket;
-	TDSCONTEXT *context = stmt->dbc->env->tds_ctx;
 
 	/* TODO handle different type results (functions) on mssql2k */
 	if (stmt->prepared_query_is_func && tds->has_status) {
@@ -139,7 +138,7 @@ odbc_set_return_status(struct _hstmt *stmt, unsigned int n_row)
 		}
 #define LEN(ptr) *((SQLLEN*)(((char*)(ptr)) + len_offset))
 
-		len = odbc_tds2sql(context, SYBINT4, (TDS_CHAR *) & tds->ret_status, sizeof(TDS_INT),
+		len = odbc_tds2sql(stmt, SYBINT4, (TDS_CHAR *) & tds->ret_status, sizeof(TDS_INT),
 				   drec->sql_desc_concise_type, (void *) data_ptr, drec->sql_desc_octet_length, NULL);
 		if (len < 0)
 			return /* SQL_ERROR */ ;
@@ -156,7 +155,6 @@ odbc_set_return_params(struct _hstmt *stmt, unsigned int n_row)
 {
 	TDSSOCKET *tds = stmt->dbc->tds_socket;
 	TDSPARAMINFO *info = tds->current_results;
-	TDSCONTEXT *context = stmt->dbc->env->tds_ctx;
 
 	int i_begin = stmt->prepared_query_is_func ? 1 : 0;
 	int i;
@@ -221,9 +219,8 @@ odbc_set_return_params(struct _hstmt *stmt, unsigned int n_row)
 		 * TODO why IPD ?? perhaps SQLBindParameter it's not correct ??
 		 * Or tests are wrong ??
 		 */
-		len = odbc_tds2sql(context, tds_get_conversion_type(colinfo->column_type, colinfo->column_size), src, srclen,
+		len = odbc_tds2sql(stmt, tds_get_conversion_type(colinfo->column_type, colinfo->column_size), src, srclen,
 				   c_type, (void *) data_ptr, drec_apd->sql_desc_octet_length, drec_ipd);
-		/* TODO error handling */
 		if (len < 0)
 			return /* SQL_ERROR */ ;
 		if (drec_apd->sql_desc_indicator_ptr)

